;;; --- "Dup90" duplicates & rotates in place -------

(defun c:Dup90 (/ ss1  ss2   AcDoc   AcSS   Ent1   ListX1    ListY1    
ListX2    ListY2   Xmin    Xmax    Ymin    Ymax    
Point1    Point2    Point3    Point4    Ctr    ep1    ep2    Dx    Dy)
(setq EntName1 (entlast))
(princ "Select objects to be duplicated...")
; ----------------------------------------------------
; get a selection set and find its centroid
(vl-load-com)  ;apparently needed by Autocad, though not by Bricscad
(setq AcDoc (vla-get-activedocument (vlax-get-acad-object)))
(setq ss1 (ssget))
(setq AcSS (vla-get-activeselectionset AcDoc))
(vlax-for Ent1 AcSS (vla-GetBoundingBox Ent1 'p1 'p2)
   (setq ListX1 (cons (car (vlax-safearray->list p1)) ListX1))
   (setq ListY1 (cons (cadr (vlax-safearray->list p1)) ListY1))
   (setq ListX2 (cons (car (vlax-safearray->list p2)) ListX2))
   (setq ListY2 (cons (cadr (vlax-safearray->list p2)) ListY2))
   )
(setq Xmin (apply 'min ListX1))
(setq Ymin (apply 'min ListY1))
(setq Xmax (apply 'max ListX2))
(setq Ymax (apply 'max ListY2))

(setq Point1 (list Xmin Ymin 0.0))
(setq Point2 (list Xmax Ymax 0.0))
(setq Point3 (list (car Point2) (cadr Point1) 0.0))
(setq Point4 (list (car Point1) (cadr Point2) 0.0))

(setq Ctr (polar Point1 (angle Point1 Point2) (/ (distance Point1 Point2) 2)))
; ----------------------------------------------------

(setq Cmode1 (getvar "COPYMODE"))
(setvar "COPYMODE" 1)
(if ss1 (command "Copy" ss1 "" "0,0" "0,0"))
(setvar "COPYMODE" Cmode1)
(setq ss2 (_ssafter EntName1))
(if ss2 (sssetfirst nil ss2) (sssetfirst nil ss1))

(command "ROTATE" "p" "" Ctr "90")
;(sssetfirst nil (ssget "P")) ;option to end with the new selection set selected for the next command
)